﻿Imports System.IO

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub ExportWord(sender As Object, e As EventArgs)
        'Convert the Relative Url to Absolute Url and set it to Image control.
        Image1.ImageUrl = Me.GetAbsoluteUrl(Image1.ImageUrl)

        Using sw As New StringWriter()
            Using hw As New HtmlTextWriter(sw)
                'Create a Table.
                Dim table As New Table()

                'Add Image control to the Table Cell.
                Dim row As New TableRow()
                row.Cells.Add(New TableCell())
                row.Cells(0).Controls.Add(Image1)
                table.Rows.Add(row)

                'Render the Table as HTML.
                table.RenderControl(hw)

                'Export the Table to Excel.
                Response.Clear()
                Response.Buffer = True
                Response.AddHeader("content-disposition", "attachment;filename=Images.doc")
                Response.Charset = ""
                Response.ContentType = "application/vnd.ms-word"

                'Write the HTML string to Response.
                Response.Write(sw.ToString())
                Response.Flush()
                Response.End()
            End Using
        End Using
    End Sub

    Public Overrides Sub VerifyRenderingInServerForm(control As Control)
        ' Verifies that the control is rendered
    End Sub

    Private Function GetAbsoluteUrl(relativeUrl As String) As String
        relativeUrl = relativeUrl.Replace("~/", String.Empty)
        Dim splits As String() = Request.Url.AbsoluteUri.Split("/")
        If splits.Length >= 2 Then
            Dim url As String = splits(0) + "//"
            For i As Integer = 2 To splits.Length - 2
                url += splits(i)
                url += "/"
            Next

            Return url & relativeUrl
        End If
        Return relativeUrl
    End Function

End Class
